﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
private Sub Class_Globals
	Private ja As JavaObject
End Sub
'@cafetoseeh
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	ja=Me
End Sub

'تشخیص اینکه گوشی هوآوی هست یاخیر
Public Sub getDeviceIsHuawei As Boolean
	Return ja.RunMethod("DeviceIsHuawei2",Null)
End Sub

'رفتن به تنظیمات برنامه های محافظت شده هوآوی
Public Sub gotoProtectedApps
	Try
		ja.RunMethod("GOTO_HuaweiSetting2",Null)
	Catch
		Log(LastException)
	End Try
End Sub

#if java
import java.io.IOException;
import java.lang.reflect.Method;
import android.os.Build;
import android.text.TextUtils;

	public static Boolean DeviceIsHuawei2(){
		return getDeviceName().toLowerCase().contains("huawei") && Build.VERSION.SDK_INT>=17 ;
	}
	
	public void GOTO_HuaweiSetting2(){
		huaweiProtectedApps();
	}
	
	private void huaweiProtectedApps() {
	    try {
	        String cmd = "am start -n com.huawei.systemmanager/.optimize.process.ProtectActivity";
	    	//String cmd = "am start -n com.wingtech.memoryclear/.whitelist.ui.ProtectedAppManageActivity";
	    	if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR1) {
	            cmd += " --user " + getUserSerial();
				//@cafetoseeh
	        }
	        Runtime.getRuntime().exec(cmd);
	    } catch (IOException ignored) {
	    	BA.Log("errorrrr");
	    }
	}

	private String getUserSerial() {
	    //noinspection ResourceType
	    Object userManager = BA.applicationContext.getSystemService("user");
	    if (null == userManager) return "";

	    try {
	    	 Method myUserHandleMethod = android.os.Process.class.getMethod("myUserHandle", (Class<?>[]) null);
	    	Object myUserHandle = myUserHandleMethod.invoke(android.os.Process.class, (Object[]) null);
	        Method getSerialNumberForUser = userManager.getClass().getMethod("getSerialNumberForUser", myUserHandle.getClass());
	        Long userSerial = (Long) getSerialNumberForUser.invoke(userManager, myUserHandle);
	        if (userSerial != null) {
	            return String.valueOf(userSerial);
	        } else {
	            return "";
	        }
		} catch (Exception e) {
			// TODO: handle exception
		}
	   
	    return "";
	}
	
	//@cafetoseeh
	
	private static String getDeviceName() {
		  String manufacturer = Build.MANUFACTURER;
		  String model = Build.MODEL;
		  if (model.startsWith(manufacturer)) {
		    return capitalize(model);
		  }
		  return capitalize(manufacturer) + " " + model;
		}

		private static String capitalize(String str) {
		  if (TextUtils.isEmpty(str)) {
		    return str;
		  }
		  char[] arr = str.toCharArray();
		  boolean capitalizeNext = true;

		  StringBuilder phrase = new StringBuilder();
		  for (char c : arr) {
		    if (capitalizeNext && Character.isLetter(c)) {
		      phrase.append(Character.toUpperCase(c));
		      capitalizeNext = false;
		      continue;
		    } else if (Character.isWhitespace(c)) {
		      capitalizeNext = true;
		    }
		    phrase.append(c);
		  }
			//@cafetoseeh
		  return phrase.toString();
		}
#End If